
use tempdb
go

create table T (
 a int,
 b int,
 c int,
 x int
)
go

insert T values(1,2,3,8)
insert T values(1,2,4,1)
insert T values(1,2,5,5)
insert T values(1,3,4,9)
go

select a, b, c, sum(x) as sumx from T
group by grouping sets (a, (b), (a, b, c))
go

-- this is equivalent to the previous query
-- but the query plan is worse (60-40)
select a, NULL as b, NULL as c, sum(x) as sumx from T
group by a
union all
select NULL as a, b, NULL as c, sum(x) as sumx from T
group by b
union all
select a, b, c, sum(x) as sumx from T
group by a, b, c
go

select a, b, c, sum(x) as sumx, grouping_id(a,b,c) as gid,
  GROUPING(a) as [GroupingByA], GROUPING(b) as [GroupingByB], GROUPING(c) as [GroupingByC]
from T
group by grouping sets (a, (b), (a, b, c))
go

SELECT a, grouping_id(a)
FROM T
GROUP BY CUBE(a,a)

-- rollup plan
SELECT a, b, c, sum(x) FROM T
GROUP BY a ,b ,c 
WITH ROLLUP

-- cube plan
SELECT a, b, c, sum(x) FROM T
GROUP BY a ,b ,c 
WITH CUBE

-- cube plan without base aggregation or spool
SELECT a, b, c  FROM T
GROUP BY GROUPING SETS ( (), (a), (a,b), (b,c), (c), (a,c), (b) )

-- naive cube plan
SELECT a, b, c, sum(distinct x)  FROM T
GROUP BY GROUPING SETS ((a,b,c), (a), ())