
use pubs
go

dbcc freeproccache
go

select * from titles where type = 'business'

create proc updatetitles (@1 varchar(20))
as
update titles 
 set price = price * 1.1
 where type = @1;
go

execute updatetitles 'business'

SELECT s.text, p.query_plan, qs.* 
FROM sys.dm_exec_query_stats qs
CROSS APPLY sys.dm_exec_sql_text(sql_handle) s
CROSS APPLY sys.dm_exec_query_plan(plan_handle) p
where s.text not like '%sys.dm_exec%'

DECLARE @plan_handle varbinary(64);
DECLARE @offset int;

SELECT @plan_handle = plan_handle, @offset = qs.statement_start_offset
FROM sys.dm_exec_query_stats AS qs
CROSS APPLY sys.dm_exec_sql_text(sql_handle) AS st
CROSS APPLY sys.dm_exec_text_query_plan(qs.plan_handle, qs.statement_start_offset, qs.statement_end_offset) AS qp
WHERE text LIKE N'%update%'
/*
AND SUBSTRING(st.text, (qs.statement_start_offset/2) + 1,
                        ((CASE statement_end_offset 
                              WHEN -1 THEN DATALENGTH(st.text)
                              ELSE qs.statement_end_offset END 
                              - qs.statement_start_offset)/2) + 1)  like 'SELECT * FROM Production.Product WHERE ProductSubcategoryID > 4%'
*/
select @plan_handle

EXECUTE sp_create_plan_guide_from_cache 
    @name =  N'Guide_For_Update_Statement',
    @plan_handle = @plan_handle,
    @statement_start_offset = @offset;
    
select * from sys.plan_guides
go
sp_control_plan_guide N'enable',N'Guide_For_Update_Statement'
go

-- execute the statement again
-- you can see plan guide usage in new profiler events
execute updatetitles 'business'