
-- 6.1.6 Curve

/*
A Curve is a 1-dimensional geometric object usually stored as a sequence of Points, with the subtype of Curve
specifying the form of the interpolation between Points. This part of ISO 19125 defines only one subclass of Curve,
LineString, which uses linear interpolation between Points.
*/

declare @ls1 geometry = 'LINESTRING(1 1, 2 2)';
declare @ls2 geometry = 'LINESTRING(0 0, 2 2, 0 2, 2 0)'; -- not simple
declare @ls3 geometry = 'LINESTRING(0 0, 2 2, 1 0, 0 0)'; -- closed, a ring
declare @ls4 geometry = 'LINESTRING(0 0, 2 2, 0 2, 2 0, 0 0)'; -- closed, not a ring

-- A Curve is simple if it does not pass through the same Point twice

select @ls1.STIsSimple(), @ls2.STIsSimple(), @ls3.STIsSimple(), @ls4.STIsSimple();

select @ls1.STIsClosed(), @ls2.STIsClosed(), @ls3.STIsClosed(),  @ls4.STIsClosed();

select @ls3.STIsRing(), @ls4.STIsRing();

select @ls1.STLength(),  @ls1.STStartPoint().ToString(), @ls1.STEndPoint().ToString();

select @ls4.STNumPoints(), @ls4.STPointN(3).ToString();