﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Collections.ObjectModel;
using System.Configuration;

namespace EnterDates
{

    public partial class Form1 : Form
    {
        BindingSource bindingSource1 = new BindingSource();
        string connString = ConfigurationManager.ConnectionStrings["Test"].ConnectionString;

        public Form1()
        {
            InitializeComponent();
            
            ReadOnlyCollection<TimeZoneInfo> tzCollection1; 
            tzCollection1 = TimeZoneInfo.GetSystemTimeZones();
            this.comboBox1.DataSource = tzCollection1;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (SqlConnection conn = new SqlConnection(connString))
            using (SqlCommand cmd = new SqlCommand("insert into datetest values(@dtoff, @entered)", conn))
            {
                cmd.Parameters.Add("@dtoff", SqlDbType.DateTimeOffset);
                cmd.Parameters.Add("@entered", SqlDbType.VarChar, 100);

                TimeZoneInfo selectedTimeZone = (TimeZoneInfo) this.comboBox1.SelectedItem;
                DateTimeOffset dt_here = DateTimeOffset.Now;
                DateTimeOffset dt_there = TimeZoneInfo.ConvertTime(dt_here, selectedTimeZone);

                cmd.Parameters[0].Value = dt_there;
                if (selectedTimeZone.IsDaylightSavingTime(dt_there))
                    cmd.Parameters[1].Value = selectedTimeZone.DaylightName;
                else
                    cmd.Parameters[1].Value = selectedTimeZone.StandardName;

                conn.Open();
                int i = cmd.ExecuteNonQuery();
                if (i == 1)
                    MessageBox.Show("New row has been entered");

            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            
            SqlDataAdapter da = new SqlDataAdapter();
            da.SelectCommand = new SqlCommand();

            da.SelectCommand.Connection = new SqlConnection(connString);

            TimeZoneInfo selectedTimeZone = (TimeZoneInfo)this.comboBox1.SelectedItem;
            DateTimeOffset dt_here = DateTimeOffset.Now;
            DateTimeOffset dt_there = TimeZoneInfo.ConvertTime(dt_here, selectedTimeZone);

            string s1 = dt_there.ToString();
            da.SelectCommand.CommandText = String.Format("select switchoffset(datetimecol, '{0:+00;-00}:{1:00}') as [EnteredDateTime], * from datetest",selectedTimeZone.BaseUtcOffset.Hours ,selectedTimeZone.BaseUtcOffset.Minutes);

            string s = da.SelectCommand.CommandText;

            dataGridView1.DataSource = bindingSource1;
            // Populate a new data table and bind it to the BindingSource.
            DataTable table = new DataTable();
            table.Locale = System.Globalization.CultureInfo.InvariantCulture;
            da.Fill(table);
            bindingSource1.DataSource = table;

            // Resize the DataGridView columns to fit the newly loaded content.
            dataGridView1.AutoResizeColumns(
                DataGridViewAutoSizeColumnsMode.AllCellsExceptHeader);

        }

    }
}
