
use test
go

create assembly orderedtvf 
from 'C:\Documents and Settings\Administrator\My Documents\Visual Studio 2008\Projects\OrderedTVF\bin\Debug\OrderedTVF.dll'

create function Fibonacci (@prevstart int, @start int, @rows int)
returns table (next int, prev int)
order (next asc)
as external name orderedtvf.FData.Fibonacci
go

create function Fibonacci2 (@prevstart int, @start int, @rows int)
returns table (next int, prev int)
order (prev asc)
as external name orderedtvf.FData.Fibonacci
go

create function FibonacciUnOrdered (@prevstart int, @start int, @rows int)
returns table (next int, prev int)
as external name orderedtvf.FData.Fibonacci
go

create function FibonacciWrong (@prevstart int, @start int, @rows int)
returns table (next int, prev int)
order (prev desc)
as external name orderedtvf.FData.Fibonacci
go

-- cost: 0.0279081 
-- TVF -> Sort -> Select
select * from dbo.FibonacciUnordered(3,4,5)
order by next

-- cost: 0.0023802
-- TVF -> Segment -> Sequence Project -> Assert -> Select
select * from dbo.Fibonacci(3,4,5)
order by next

-- Wrong order
-- cost: 0.0292881
-- TVF -> Segment -> Sequence Project -> Assert -> Sort -> Select
select * from dbo.Fibonacci(3,4,5)
order by prev

-- cost: 0.0023802
-- TVF -> Segment -> Sequence Project -> Assert -> Select
select * from dbo.Fibonacci2(3,4,5)
order by prev

-- The order of the data in the stream does not conform to the ORDER hint 
-- specified for the CLR TVF 'dbo.FibonacciWrong'. 
-- The order of the  data must match the order specified in the ORDER hint for a CLR TVF. 
-- Update the ORDER hint to reflect the order in which the input data is ordered, 
-- or update the CLR TVF to match the order specified by the ORDER hint.
select * from dbo.FibonacciWrong(3,4,5)
order by prev
