use tempdb
go
drop xml schema collection lax_example
go
create xml schema collection lax_example
as
'<xs:schema attributeFormDefault="unqualified" elementFormDefault="qualified" 

xmlns:xs="http://www.w3.org/2001/XMLSchema">
	<xs:element name="people">
		<xs:complexType>
			<xs:sequence>
				<xs:element maxOccurs="unbounded" name="person">
					<xs:complexType>
						<xs:sequence>
							<xs:element name="name">
								<xs:complexType>
									<xs:sequence>
										<xs:element name="givenName" type="xs:string" />
										<xs:element name="familyName" type="xs:string" />
									</xs:sequence>
								</xs:complexType>
							</xs:element>
							<xs:element name="age" type="xs:integer" />
							<xs:element name="height" type="xs:string" />
						</xs:sequence>
					</xs:complexType>
				</xs:element>
			</xs:sequence>
		</xs:complexType>
	</xs:element>
        <xs:element name="OpenPerson" >
                <xs:complexType >
           <xs:sequence>
               <xs:any processContents="lax" namespace="##any" />
           </xs:sequence>
        </xs:complexType>
</xs:element>
</xs:schema>'
go
use tempdb
go
--Using the OpenPerson element we can add any sub element
--due to the lax validation
declare @x xml (lax_example) = '<OpenPerson><someRandomElement >
<somethingelse /></someRandomElement >
</OpenPerson>'

--Highlights that use of an element that is in the schema the element
--still has to be schema valid
declare @x xml (lax_example) = '<OpenPerson><people ></people>
</OpenPerson>'

go
--With a complete element the xml validates
declare @x xml (lax_example) = 
'<OpenPerson>
   <people >
      <person>
         <name>
           <givenName />
           <familyName />
         </name>
         <age >2008</age>
         <height >1.8</height>
       </person>
   </people>
</OpenPerson>'


